

// rev  29/06/2020
//  lecture temperature interne DS3231  char * Ds3231_Temp_CP(char mode)
// rev  21/02/2019
#include "Tiny_RTC_DS3231_HARDW_I2C1_for_K42_2020_07.h"
extern unsigned char tmp[];
#define Print UART1_Write_Text

char * Ds3231_Temp_CP(char mode)
  {
   char DS_Temp[9];
   // " range: -99 to +127 degree
   char msb, lsb, tmp;
    // read the two temperature registers:
    DS_Temp[0]=0x11 ;
    I2C1_Wr( DS3231_ADDR,  DS_Temp, 1,  _I2C_END_MODE_STOP );   //1ere adresse
    I2C1_Rd( DS3231_ADDR,  DS_Temp, 2, _I2C_END_MODE_STOP );   // read  MSB + LSB Temp
    msb =DS_Temp[0];
    lsb= DS_Temp[1];
   tmp = ' ';
   if (msb.B7)
   { // SIGN_bit = 1: negative
      tmp = '-';
      // two's complement conversion:
      msb ^= 0xFF;
      if (!lsb)
         ++msb; // required if the fractional portion is zero
      else
         lsb.B0 = 1; // negative fract. sign, normally it is 0
   }
   else
   {
   if (msb > 99)
   {
      msb -= 100;
      tmp = '1';
   }
   }
   // the first char is a space, '-' or '1':
   DS_Temp[0]=tmp;
   //Lcd_Chr_CP(tmp);
   // convert msb (binary value) to 2 ASCII digits
   for ( tmp = '0' ; msb > 9 ; ++tmp, msb -= 10 );
   // display integer portion:
   DS_Temp[1]=tmp;
   DS_Temp[2]=msb+'0';
   // decimal point:
   DS_Temp[3]= '.';
   // compute fract. part:
   msb = '0';
   tmp = '0';
   if (lsb)
   {
      // positive 7,6 bits: 01(25), 10(50), 11(75)
      // negative 7,6 bits: 01(75), 10(50), 11(25)
      if (!lsb.B6)
         msb = '5'; // 50
      else
      {
         msb = '2';
         tmp = '5';
         if (lsb.B0) // negative fract. (see above): 25 <> 75
            lsb.B7 = !lsb.B7;
         if (lsb.B7)
            msb = '7';
      }
   } // fract. part

   DS_Temp[4]= msb;
   DS_Temp[5]= tmp;
  if (mode==0)  DS_Temp[6]=''; else DS_Temp[6]= 0xDF;  // for LCD
   DS_Temp[7]= 'C';
   DS_Temp[8]=0;
   return DS_Temp;
} // end of Ds3231_Temp_CP()


void write_DS3231(unsigned char address,unsigned char w_data)  // I2C WRITE
 {
    tmp[0]=address ;
    tmp[1]= w_data;
     I2C1_Wr( DS3231_ADDR, tmp, 2, _I2C_END_MODE_STOP );
 }
 
unsigned char read_DS3231(unsigned char address)      // I2C read subroutine
{unsigned char  cd  ;

    tmp[0]=address ;
    I2C1_Rd( DS3231_ADDR, tmp, 1, _I2C_END_MODE_STOP );
  return(tmp[0]);
 }
 
void read_all_DS3231(void)      // Lecture Date et heure seulement
{
    // relecture RTC   en BCD
      tmp[0]=0 ;
      I2C1_Wr( DS3231_ADDR, tmp, 1,  _I2C_END_MODE_RESTART );
      I2C1_Rd( DS3231_ADDR, tmp, 7, _I2C_END_MODE_STOP );        //was 18 =all register
      second=tmp[0];
      minute=tmp[1];
      heure=tmp[2];
      jS=tmp[3] & 0x0007;  // 1  7
      if (jS>7) jS=0;
      jour=tmp[4];
      mois=tmp[5] & 0x1F; ;
      Annee=tmp[6];
      Month=Bcd2Dec(mois);
      Sec= Bcd2Dec(second);
 }
 



 void BCD_To_Ascii(unsigned char cc,unsigned char * px)
 {
 *(px)=(cc>>4) + 48;
 *(px+1)=(cc & 0x0F) +48;
 *(px+2)=0;
 }


void Display_Date_Time(char Visu)
{   unsigned char cx,mx,hx;
   read_all_DS3231();   // lecture en bloc des 6 registre
 //  Refresh_Date_Time();   // lecture individuelle des registre
    time[0]=0;
    date[0]=0;
     BCD_To_Ascii(heure,time) ;   time[2]='H';
     BCD_To_Ascii(minute,time+3 );  time[5]='M';
     BCD_To_Ascii(second,time+6);   time[8]='S';time[9]=0;
     BCD_To_Ascii(jour,date); date[2]='/';
     BCD_To_Ascii(mois,date+3); date[5]='/';
     BCD_To_Ascii(Annee,date+6); date[8]=0;
     Month=Bcd2Dec(mois);
     Sec= Bcd2Dec(second);
   if( Visu==1)
   {   UART1_Write_Text(date);
    CPrint(Blancs);
     UART1_Write_Text(time);
    CPrint(Blancs);
     }
    // Re-Lecture RTC  :   05-11-17 14:37:24

  }




  void Refresh_Date_Time(void)
{   // GIE_bit=0;
     second=read_DS3231(0);
     minute=read_DS3231(1);
     heure =read_DS3231(2);
     jS=read_DS3231(3) ;
     if (jS>7) jS=0;
     jour=read_DS3231(4);
     mois=read_DS3231(5);
     Annee=read_DS3231(6);
       Month=Bcd2Dec(mois) & 0x01F;
       if (Month>12) Month=0;
    // GIE_bit=1;
  }



void MAJ_RTC()
{ int m,i,j,k;
  m=2; // passe par dessus "U;"
  // U;24;08;17;17;36;02#
  CRLF1();
  j=0;
  //Status=0;
   U1RXIE_bit=0;
  *(Buffer1+Index1)=0;
   if ((Index1<22)&&(Index1>19))
    {
       // CPrint(" Index1 = ");
       // WordToStr(Index1,CRam1);
       // UART1_Write_Text(CRam1);
       // CRLF1();
        for (i=2;i<Index1;i++)
        {
          if(Buffer1[i]==';')
              {
                Buffer1[i]=0;
                DateTime[j]=atoi(Buffer1+m);
              UART1_Write_Text(Buffer1+m);CRLF1();
               j++;
               m=i+1;   // m=i+1;
              }
       }// for i
        DateTime[j]=atoi(Buffer1+m);
        jour=DateTime[0];
        mois=DateTime[1] & 0x1F;
        Annee=DateTime[2];
        heure=DateTime[3];
        minute=DateTime[4];
        jS=DateTime[5] & 0x07; // jour de la semaine
        CPrint("\r\n Jour Semaine jS =");
        ByteToStr(jS,CRam1);
        UART1_Write_Text(CRam1);
        UART1_Write(9);
        CPrint(JourSemaine[jS]);  UART1_Write(9);
        CPrint(" mois ="); 
        Month=Bcd2Dec(mois);
        if (Month>12) Month=0;
        CPrint( Douze_Mois[Month]);
        CRLF1();

        if (jS>7)
        {
             jS=0;  // error si defaut !
              CPrint("\r\nErreur sur Jour Semaine jS. \r\n");
        }


        tmp[0]=0x00; // adresse 0
        second=0;
        tmp[1]=second; //Reset second to 0 sec. and stop Oscillator
        tmp[2]=Dec2Bcd(minute); //write min
        tmp[3]=Dec2Bcd(heure); //write hour
        tmp[4]=jS; //write day of week
        tmp[5]=Dec2Bcd(jour); // write date
        tmp[6]=Dec2Bcd(mois); // write month
        tmp[7]=Dec2Bcd(Annee); // write year
         tmp[8]=0x00;
        I2C1_Wr(DS3231_ADDR, tmp, 7, _I2C_END_MODE_STOP );
       #ifdef RTC_1307
         tmp[0]=0x07;
         tmp[1]=0x10;   // OUT=x  SQWE=1  RS1=0 RS0=0   1HZ
         I2C1_Wr(DS3231_ADDR, tmp, 1, _I2C_END_MODE_STOP );
             #else
         tmp[0]=0x0E;
         tmp[1]=0x40;   // BSQW=1  RS1=0 RS0=0   1HZ
         I2C1_Wr(DS3231_ADDR, tmp, 1, _I2C_END_MODE_STOP );
        #endif

      CPrint("Ecriture en bloc dans DS3231... OK\r\n");
      CRLF1();
    }
    else
    {
    CPrint("\r\n Rappel format de cde : \"U;JJ;MM;AA;HH;MM;jS;#\" \r\n");
    CPrint(" U;24;08;17;18;36;04#  pour 24 Aout 2017  18H36 04=Jeudi\r\n\r\n");
    }

 }